extrn   v86r_eax:dword, v86r_ebx:dword, v86r_ecx:dword, v86r_edx:dword
extrn   v86r_esi:dword, v86r_edi:dword, v86r_ebp:dword
extrn   v86r_ah:byte, v86r_al:byte, v86r_bh:byte, v86r_bl:byte
extrn   v86r_ch:byte, v86r_cl:byte, v86r_dh:byte, v86r_dl:byte
extrn   v86r_ax:word, v86r_bx:word, v86r_cx:word, v86r_dx:word
extrn   v86r_si:word, v86r_di:word, v86r_bp:word
extrn	v86r_ds:word, v86r_es:word, v86r_fs:word, v86r_gs:word, v86r_flags:word
extrn	_selcode:word, _seldata:word, _selzero:word, _lomembase:dword
extrn	_lomemtop:dword, _himembase:dword, _himemtop:dword, _pspa:dword, _enva:dword
extrn   _code16a:dword, _code32a:dword, _getirqvect:dword, _setirqvect:dword
extrn   _sysbyte0:byte, _irqmode:word, _setselector:dword, _exitcode:byte

extrn   _getmem:near, _getlomem:near, _gethimem:near, _lomemsize:near
extrn   _himemsize:near, _ret:near, _exit:near, _getirqmask:near
extrn   _setirqmask:near, _rmpmirqset:near, _rmpmirqfree:near
extrn   _getselector:near, _freeselector:near, _rmcall:near, _rmint:near


; Convert physical pointer to realative pointer
@rlp            macro reg, ptr
                mov &reg,&ptr
                sub &reg,_code32a
endm

; Convert realative pointer to physical pointer
@php            macro reg, ptr
                mov &reg,&ptr
        	add &reg,_code32a
                endm

; Output a byte to DX
@outb           macro   val
                mov al,&val
                out dx,al
                endm

; Output a word to DX
@outw           macro   val
                mov ax,&val
                out dx,ax
                endm


; FAUST: Removed the interrupt flag macros because WINDOWS sometimes hung up
; with them, may also be that I used them incorrectly!!!



; Note: from now on everything is added by FAUST, and an increasing factor of
; stupidity may be present.

; Safe word output for graphics operations, does it as two bytes
@soutw          macro   val
                mov ax,&val
                out dx,al
                inc dx
                mov al,ah
                out dx,al
                dec dx
                endm

; An important thing to remember about these 16-bit macros:
; no more than one 16-bit prefix is needed. @rep16 stosw would use the 16-bit
; counter but ALSO 16-bit addressing. If you really need an address and a
; counter of different sizes, use loop or @loop16 instead. And I think there's
; not much use for a 32-bit counter and 16-bit addressing in the same loop...

; Note also that with stosw and stosd, they still go over the segment if the
; wrap should happen in the middle of the instruction. Of course, the easiest
; solution would be to stop making memory wrapping scrollers (speed would be
; be gained + no need for SVGA compatibility) but then there could be no more
; infinite scrolling!

; 16-bit stosb for graphics operations
@stosb16        macro
                db 67h,0aah
                endm

; 16-bit stosw for graphics operations
@stosw16        macro
                db 66h,67h,0abh                 ;Weird but it works!
                endm

; 16-bit stosd for graphics operations
@stosd16        macro
                db 67h,0abh
                endm

; 16-bit loops (for graphics operations, I guess...)
@loop16         macro   label
                db 67h                  ;16-bit prefix
                loop label
                endm

@rep16          macro   action
                db 67h                  ;16-bit prefix
                rep action
                endm

; Some useful macros in game programming:

; Limit checking (signed)

@limit          macro   dest, low, high
                local   @nothigh, @notlow
                cmp     &dest, &high
                jng     @nothigh
                mov     &dest, &high
@nothigh:       cmp     &dest, &low
                jnl     @notlow
                mov     &dest, &low
@notlow:        endm

; Limit checking (signed) and clearing of additional label if limit exceeded

@lzero          macro   dest, low, high, cleared
                local   @nothigh, @notlow
                cmp     &dest, &high
                jng     @nothigh
                mov     &dest, &high
                mov     cleared, 0
@nothigh:       cmp     &dest, &low
                jnl     @notlow
                mov     &dest, &low
                mov     cleared, 0
@notlow:        endm

; Reduce towards zero (signed)

@reduce         macro   dest, speed
                local   @increase, @ready
                cmp     &dest, 0
                je      @ready
                jle     @increase
                sub     &dest, &speed
                jns     @ready
                mov     &dest, 0
                jmp     @ready
@increase:      add     &dest, &speed
                js      @ready
                mov     &dest, 0
@ready:         endm

@hermetic_sar   macro   dest, amount
                local   negative, alldone
                cmp     &dest, 0
                jl      negative
                shr     &dest, &amount
                jmp     alldone
negative:       neg     &dest
                shr     &dest, &amount
                neg     &dest
alldone:        endm

;And some useful constants
FALSE           equ     0
TRUE            equ     1
CARRYFLAG       equ     1
